' ==========================================
'  APROL Application Compiler v3.7 for DOS
'  Created in QBasic 7.1 As Part of the
'  GCOE G2 Kernal Development System.
' ==========================================

' ==[ Subroutine Declares ]=================

    DECLARE FUNCTION ProcessMetaLine$ (iStr AS STRING)
    DECLARE FUNCTION ProcessLine$ (iStr AS STRING)
    DECLARE FUNCTION Trim$ (iStr AS STRING)
    DECLARE SUB LoadTokens (iStr AS STRING)

' ==[ Variable Declares ]===================

    DIM SHARED clrHighlight AS INTEGER
    DIM SHARED clrNormal AS INTEGER
    DIM SHARED strTokens(500, 1) AS STRING
    DIM SHARED intTotalTokens AS INTEGER
    DIM strFilename AS STRING
    DIM strProgram AS STRING
    DIM strSourceLine AS STRING
    DIM strDestLine AS STRING
    DIM intLooper AS INTEGER
    DIM intSourceFileHandle AS INTEGER
    DIM intDestFileHandle AS INTEGER
        
' ==[ Program ]=============================

    ' CHDIR "c:\g2" ' for development

    clrHighlight = 15: clrNormal = 7
    PRINT : COLOR clrHighlight: PRINT "  APROL Application Compiler v3.7 for DOS": COLOR clrNormal: PRINT

    IF INSTR(1, LCASE$(COMMAND$), "-") <> 0 THEN
        strFilename = Trim$(MID$(COMMAND$, INSTR(LCASE$(COMMAND$), "-") + 1, LEN(COMMAND$)))
        PRINT "    >> compiling "; : COLOR clrHighlight: PRINT strFilename; : COLOR clrNormal: PRINT " into "; : COLOR clrHighlight: PRINT LEFT$(strFilename, LEN(strFilename) - 3) + "EXE": COLOR clrNormal
        LoadTokens "Tokens.lst"
        intSourceFileHandle = FREEFILE
        OPEN strFilename FOR INPUT AS #intSourceFileHandle
            intDestFileHandle = FREEFILE
            OPEN LEFT$(strFilename, LEN(strFilename) - 3) + "TMP" FOR OUTPUT AS #intDestFileHandle
                DO UNTIL EOF(intSourceFileHandle)
                    LINE INPUT #intSourceFileHandle, strSourceLine
                    strSourceLine = ProcessMetaLine$(strSourceLine)
                    IF strSourceLine <> "" THEN
                      PRINT #intDestFileHandle, strSourceLine
                    END IF
                LOOP
            CLOSE #intDestFileHandle
        CLOSE #intSourceFileHandle
        strFilename = LEFT$(strFilename, LEN(strFilename) - 3) + "TMP"
        OPEN strFilename FOR INPUT AS #intSourceFileHandle
            intDestFileHandle = FREEFILE
            OPEN LEFT$(strFilename, LEN(strFilename) - 3) + "EXE" FOR OUTPUT AS #intDestFileHandle
                DO UNTIL EOF(intSourceFileHandle)
                    LINE INPUT #intSourceFileHandle, strSourceLine
                    strSourceLine = ProcessLine$(strSourceLine)
                    strProgram = strProgram + strSourceLine
                LOOP
                PRINT #intDestFileHandle, strProgram
            CLOSE #intDestFileHandle
        CLOSE #intSourceFileHandle
        KILL LEFT$(strFilename, LEN(strFilename) - 3) + "TMP"
    ELSE
        PRINT "    >> Use -[FILENAME] to compile programs."
    END IF

    SYSTEM

    SUB LoadTokens (iStr AS STRING)
        
        DIM intFilenum AS INTEGER
        DIM strTemp AS STRING
        DIM intCurrentToken AS INTEGER
        
        intCurrentToken = -1
        intFilenum = FREEFILE
        OPEN iStr FOR INPUT AS #intFilenum
            DO UNTIL EOF(intFilenum)
                INPUT #intFilenum, strTemp
                IF NOT LEFT$(strTemp, 2) = "//" THEN
                    intCurrentToken = intCurrentToken + 1
                    strTokens(intCurrentToken, 0) = strTemp
                    INPUT #intFilenum, strTemp
                    strTokens(intCurrentToken, 1) = strTemp
                END IF
            LOOP
        CLOSE #intFilenum
        intTotalTokens = intCurrentToken
        
    END SUB

    FUNCTION ProcessLine$ (iStr AS STRING)
        
      DIM strProcessLine AS STRING
      DIM strChr AS STRING
      DIM intStringLoop AS INTEGER
      DIM intTokenLoop AS INTEGER
      DIM intIsInQuotes AS INTEGER
      DIM intDone1 AS INTEGER
        
      FOR intStringLoop = 1 TO LEN(iStr) STEP 1
          strChr = MID$(iStr, intStringLoop, 1)
          IF strChr = CHR$(34) THEN
              IF intIsInQuotes = 0 THEN
                  intIsInQuotes = 1
              ELSE
                  intIsInQuotes = 0
                  strProcessLine = strProcessLine + ""
              END IF
          ELSEIF intIsInQuotes = 1 THEN
              strProcessLine = strProcessLine + strChr
          ELSEIF ASC(strChr) >= 48 AND ASC(strChr) <= 57 THEN
              intDone1 = 0
              DO
                  strProcessLine = strProcessLine + strChr
                  intStringLoop = intStringLoop + 1
                  IF intStringLoop > LEN(iStr) THEN
                      strProcessLine = strProcessLine + ""
                      intDone1 = 1
                  ELSE
                      strChr = MID$(iStr, intStringLoop, 1)
                      IF ASC(strChr) < 48 OR ASC(strChr) > 57 THEN
                          strProcessLine = strProcessLine + ""
                          intStringLoop = intStringLoop - 1
                          intDone1 = 1
                      END IF
                  END IF
              LOOP UNTIL intDone1 = 1
          ELSE
              FOR intTokenLoop = 0 TO intTotalTokens STEP 1
                  IF LCASE$(MID$(iStr, intStringLoop, LEN(strTokens(intTokenLoop, 0)))) = LCASE$(strTokens(intTokenLoop, 0)) THEN
                      strProcessLine = strProcessLine + strTokens(intTokenLoop, 1)
                      intStringLoop = intStringLoop + (LEN(strTokens(intTokenLoop, 0)) - 1)
                      EXIT FOR
                  END IF
              NEXT
          END IF
      NEXT intStringLoop
      ProcessLine$ = strProcessLine
    END FUNCTION

    FUNCTION ProcessMetaLine$ (iStr AS STRING)

      DIM strProcessLine AS STRING
      DIM strChr AS STRING
      DIM intStringLoop AS INTEGER
      DIM aTemp AS STRING
      DIM iTemp(20) AS STRING
      DIM intCur AS INTEGER
      
      IF LEFT$(Trim$(LCASE$(iStr)), 1) = "#" THEN
        FOR intStringLoop = 1 TO LEN(iStr) STEP 1
          strChr = MID$(Trim$(iStr), intStringLoop, 1)
          IF strChr = "," THEN
            iTemp(intCur) = aTemp
            intCur = intCur + 1
            aTemp = ""
          ELSEIF strChr = " " THEN
            IF intCur = 0 THEN
              iTemp(intCur) = aTemp
              intCur = intCur + 1
              aTemp = ""
            END IF
          ELSE
            aTemp = aTemp + strChr
          END IF
        NEXT
        iTemp(intCur) = aTemp
        IF Trim$(iTemp(0)) = "#dim" THEN
          intTotalTokens = intTotalTokens + 1
          strTokens(intTotalTokens, 0) = Trim$(iTemp(1))
          strTokens(intTotalTokens, 1) = CHR$(184) + Trim$(iTemp(2)) + CHR$(255)
          intTotalTokens = intTotalTokens + 1
          strTokens(intTotalTokens, 0) = "_" + Trim$(iTemp(1))
          strTokens(intTotalTokens, 1) = Trim$(iTemp(2)) + CHR$(255)
        END IF
        ProcessMetaLine$ = ""
      ELSEIF LEFT$(Trim$(LCASE$(iStr)), 2) = "//" THEN
        ProcessMetaLine$ = ""
      ELSE
        ProcessMetaLine$ = iStr
      END IF

    END FUNCTION

    FUNCTION Trim$ (iStr AS STRING)
    
        Trim$ = LTRIM$(RTRIM$(iStr))
        
    END FUNCTION

